#ifndef WJO_NOISE
#define WJO_NOISE
#define MAX_DIMENSIONS 3
#include "warjo_tertex.h"
#include <math.h>
// Inline functions (use instead of macros to avoid performing slow operations twice)
inline int Floor(float a)						{ return ((int)a - (a < 0 && a != (int)a)); }


class Noise {
	float f_stat[4096][3];
	

public:
	Noise()	{}
	Noise(unsigned int nSeed)	{ Init(nSeed); }
	void Init(unsigned int nSeed) {
		srand(nSeed);
		for(int i=0;i<4096;i++) {
			f_stat[i][0]=(float)rand()/(float)RAND_MAX;
			f_stat[i][1]=(float)rand()/(float)RAND_MAX;
			f_stat[i][2]=(float)rand()/(float)RAND_MAX;

			float t=0;
			for(int j=0;j<3;j++) t+=f_stat[i][j]*f_stat[i][j];
			t=sqrt(t);
			for(j=0;j<3;j++) f_stat[i][j]=f_stat[i][j]/t;

		}
	}
	float GetVal(int nx,int ny,float rx,float ry,int i) {
		nx=nx&63;
		ny=ny&63;
		
		float p=f_stat[nx+ny*64][i];
		float t=(1-rx)*(1-ry);
		return p*t;
	}


	float GetNoise(float fx,float fy) {
		int nx=Floor(fx);
		int ny=Floor(fy);
		float rx=fx-nx;
		float ry=fy-ny;

		float ft=0;
		for(int i=0;i<1;i++)
			ft= (GetVal(nx,ny,rx,ry,i)+GetVal(nx+1,ny,1-rx,ry,i)+
			GetVal(nx,ny+1,rx,1-ry,i)+GetVal(nx+1,ny+1,1-rx,1-ry,i))*0.25f;

		return  (ft>1.0f)?1:ft;

	}

	float turb(float x, float y) {
	float f=0.0f, s=1.0f, d=1.0f;
	for (int i=0; i<5; i++) {
		f+=GetNoise(x*s, y*s)*d;
		s*=2.0f;
		d*=0.5f;
	}
	return f;
}
};


#endif